﻿Imports System
Imports System.Reflection

Public Class frmMasterForm

    Private c_oWisysConnection As Wisys.AllSystem.ConnectionInfo
    Private c_sUserControlName As String = ""

    Public Sub New(sApplicationName As String, sUserControlName As String, ByRef oWisysConneciton As Wisys.AllSystem.ConnectionInfo)
        ' This call is required by the designer.
        InitializeComponent()

        lblTitle.Text = sApplicationName
        c_sUserControlName = sUserControlName
        c_oWisysConnection = oWisysConneciton

    End Sub

    Private Sub frmMasterForm_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        tLBLConnectionInformation.Text = c_oWisysConnection.Server & " : " & c_oWisysConnection.Database
        CreateExampleControl()

    End Sub

    Private Sub CreateExampleControl()

        Try            
            Dim p_ucExampleUserControl As Object = Nothing
            Dim p_oUserControlType As Type = Type.GetType(Assembly.GetExecutingAssembly.GetName.Name & "." & c_sUserControlName)
            Dim parameters(0) As Object

            parameters(0) = c_oWisysConnection
            p_ucExampleUserControl = Activator.CreateInstance(p_oUserControlType, parameters)
            Dim uc = CType(p_ucExampleUserControl, UserControl)
            Me.Width = uc.Width + 20
            Me.Height = pnlMasterHeader.Height + uc.Height + StatusStrip1.Height + 20
            pnlUserControl.Controls.Add(uc)
            pnlUserControl.Controls(0).Dock = DockStyle.Fill

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        'Dim o As Object = Nothing
        'Dim nspc As String = p_sFullyQualifiedClass.Substring(0, p_sFullyQualifiedClass.LastIndexOf("."c))
        'o = Assembly.Load(nspc).CreateInstance(p_sFullyQualifiedClass)
        'Dim uc = CType(o, UserControl)
        'Dim ci As ConstructorInfo = t.GetConstructor(types)
        'Dim instance As Object = ci.Invoke(parameters)
        'Dim t As Type = GetType(Wisys.Examples.ucARCreateCustomer)


    End Sub

    Private Sub CleanUp()

        If (pnlUserControl IsNot Nothing AndAlso pnlUserControl.Controls.Count > 0) Then
            For index = 0 To pnlUserControl.Controls.Count - 1
                pnlUserControl.Controls(index).Dispose()
            Next
        End If

    End Sub

    Private Sub btnExit_Click(sender As System.Object, e As System.EventArgs) Handles btnExit.Click
        CleanUp()
        Me.Close()
    End Sub

    'Private Sub pnlMasterDetail_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles pnlMasterDetail.Paint

    'End Sub
    'Private Sub SplitContainer1_SplitterMoved(sender As System.Object, e As System.Windows.Forms.SplitterEventArgs) Handles SplitContainer1.SplitterMoved

    'End Sub
    'Private Sub pnlMasterForm_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles pnlMasterForm.Paint

    'End Sub
    'Private Sub lblTitle_Click(sender As System.Object, e As System.EventArgs) Handles lblTitle.Click

    'End Sub
    'Private Sub Panel1_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles Panel1.Paint

    'End Sub
    'Private Sub pnlUserControl_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles pnlUserControl.Paint

    'End Sub
    'Private Sub Panel2_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles Panel2.Paint

    'End Sub
    'Private Sub TableLayoutPanel1_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles TableLayoutPanel1.Paint

    'End Sub
    'Private Sub pnlMasterHeader_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles pnlMasterHeader.Paint

    'End Sub
    'Private Sub tsLBLTransactionMessage_Click(sender As System.Object, e As System.EventArgs) Handles tsLBLTransactionMessage.Click

    'End Sub
    'Private Sub tLBLConnectionInformation_Click(sender As System.Object, e As System.EventArgs) Handles tLBLConnectionInformation.Click

    'End Sub
    'Private Sub ToolStripStatusLabel1_Click(sender As System.Object, e As System.EventArgs) Handles ToolStripStatusLabel1.Click

    'End Sub
    'Private Sub StatusStrip1_ItemClicked(sender As System.Object, e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles StatusStrip1.ItemClicked

    'End Sub
End Class