﻿Public Class cOrderEntryLine

#Region "Variables"

    Private c_iLineNo As Integer
    Private c_sItemNo As String
    Private c_sLocation As String
    Private c_dQtyOrdered As Double
    Private c_dQtyToShip As Double
    Private c_dPrice As Double
    Private c_dCost As Double
    Private c_dtRequestDate As DateTime
    Private c_dtPromiseDate As DateTime
    Private c_dtRequestShipDate As DateTime

#End Region

#Region "Properties"

    Public Property LineNo As Integer
        Get
            Return c_iLineNo
        End Get
        Set(value As Integer)
            c_iLineNo = value
        End Set
    End Property

    Public Property ItemNo() As String
        Get
            Return c_sItemNo
        End Get
        Set(ByVal value As String)
            c_sItemNo = value
        End Set
    End Property

    Public Property Location() As String
        Get
            Return c_sLocation
        End Get
        Set(ByVal value As String)
            c_sLocation = value
        End Set
    End Property

    Public Property QtyOrdered() As Double
        Get
            Return c_dQtyOrdered
        End Get
        Set(ByVal value As Double)
            c_dQtyOrdered = value
        End Set
    End Property

    Public Property QtyToShip() As Double
        Get
            Return c_dQtyToShip
        End Get
        Set(ByVal value As Double)
            c_dQtyToShip = value
        End Set
    End Property

    Public Property Price() As Double
        Get
            Return c_dPrice
        End Get
        Set(ByVal value As Double)
            c_dPrice = value
        End Set
    End Property

    Public Property Cost() As Double
        Get
            Return c_dCost
        End Get
        Set(ByVal value As Double)
            c_dCost = value
        End Set
    End Property

    Public Property RequestDate() As DateTime
        Get
            Return c_dtRequestDate
        End Get
        Set(ByVal value As DateTime)
            c_dtRequestDate = value
        End Set
    End Property

    Public Property PromiseDate() As DateTime
        Get
            Return c_dtPromiseDate
        End Get
        Set(ByVal value As DateTime)
            c_dtPromiseDate = value
        End Set
    End Property

    Public Property RequestShipDate() As DateTime
        Get
            Return c_dtRequestShipDate
        End Get
        Set(ByVal value As DateTime)
            c_dtRequestShipDate = value
        End Set
    End Property

#End Region

#Region "Constructor"

    Public Sub New()
        c_dPrice = -1
        c_dCost = -1
        c_dtRequestDate = DateTime.Now
        c_dtRequestShipDate = DateTime.Now
        c_dtPromiseDate = DateTime.Now

    End Sub

#End Region

End Class
